﻿// Plugin Developed by Naut
using System;
using System.Collections.Generic;
using System.Threading;
using System.Xml.Linq;
using System.Diagnostics;
using System.IO;
using System.Xml;
using System.Windows.Forms;
using System.Net;
using System.Globalization;
using System.Windows.Media;
using System.Media;
using System.Linq;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.Pathing;
using Styx.WoWInternals.World;

namespace Naut
{
    public class WarlockAssist : HBPlugin
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
		
		#region Default Overrides
        public override string Name { get { return "WarlockAssist"; } }
        public override string Author { get { return "Naut"; } }
        public override Version Version { get { return new Version(1, 0, 0, 1); } }
        public override string ButtonText { get { return "WarlockAssist"; } }
        public override bool WantButton { get { return false; } }
		private List<WoWUnit> unitsToDot;
        private List<WoWUnit> DotableUnits;
        private WoWUnit SelectedAliveTarget { get; set; }
        public int MobCount { get; private set; }
		#endregion Default Overrides
		
		public override void Pulse()
        {	
			if (Me.GotTarget)
			{
				if (Me.CurrentTarget.IsAlive && !Me.CurrentTarget.HasAura("Corruption")) 
				{
					SpellManager.Cast("Corruption");
				}
				if (Me.CurrentTarget.IsAlive && Me.CurrentTarget.HasAura("Corruption") && !Me.CurrentTarget.HasAura("Agony")) 
				{
					SpellManager.Cast("Agony");
				}
				//if (Me.CurrentTarget.IsAlive && Me.CurrentTarget.HasAura("Corruption") && Me.CurrentTarget.HasAura("Agony") && !Me.CurrentTarget.HasAura("Unstable Affliction")) 
				//{
				//	SpellManager.Cast("Unstable Affliction");
				//}
			}
			if (Me.Combat)
			{
				if (!Me.Combat && Me.IsAlive && !Me.IsGhost && !Me.IsOnTransport && !Me.OnTaxi && !Me.Stunned && !Me.IsCasting) 
				{
					FindDotTarget();
				}
			}
        }
		
		private void FindDotTarget()
        {
            unitsToDot = new List<WoWUnit>();
            unitsToDot = GetDotableUnits();
            for (int i = 0; i < unitsToDot.Count(); i++)
            {
                if (unitsToDot[i].Distance < 40 && !unitsToDot[i].HasAura("Corruption"))
                {
                    SpellManager.Cast("Corruption", unitsToDot[i]);
					StyxWoW.SleepForLagDuration();
                }
            }
        }

        private List<WoWUnit> GetDotableUnits()
        {
            DotableUnits = (ObjectManager.GetObjectsOfType<WoWUnit>(true, true)
                        .Where(unit =>
                        !unit.IsDead &&
                        !unit.IsCritter &&
                        !unit.HasAura("Corruption") &&
						!unit.Elite &&
						!unit.IsNeutral &&
                        !unit.IsFriendly)
                        .OrderBy(unit => unit.Distance)).ToList<WoWUnit>();
            List<WoWUnit> units = new List<WoWUnit>();

            if (DotableUnits != null && DotableUnits.Count >= 1)
            {
                for (int index = 0; index < 1; index++)
                {
                    units.Add(DotableUnits[index]);
                }
            }
            else if (DotableUnits != null)
            {
                for (int index = 0; index < DotableUnits.Count; index++)
                {
                    units.Add(DotableUnits[index]);
                }
            }
            return units;
        }  
    }
}
